/* Masterbrain-Spiel:
 * Der Spieler denkt sich eine Zahl aus
 *  - der Computer muss sie erraten.
 *
 * Stefan Arnold XI.03
 */

#include <stdio.h>
#include <stdlib.h>

#define CODELAENGE 4

#include "Mastermind.h"

int main()
{
    zahl Optionen;

    /* Menge der verbleibenden Moeglichkeiten.
       Gesetztes Bit = zugehoerige Kombination
                       ist Element der Menge */
    menge M;
    int charZahl,i;
    code Tip;
    bewertung b;

    /* Einlesen der groessten erlaubten Zahl in Codes */
    printf("Wieviele Zahlen sollen zur Auswahl stehen?\n");
    scanf("%u",&Optionen);
    if (Optionen==0)
    {
        printf("Dann halt nicht...\n");
        return 0;
    }
    Optionen=Optionen>MAX_OPTIONEN? MAX_OPTIONEN: Optionen;
    Optionen=Optionen<CODELAENGE? CODELAENGE: Optionen;
    printf("Sie koennen aus den Zahlen 0..%u auswaehlen.\n",Optionen-1);

    M.size=1;
    for(i=0;i<CODELAENGE;i++)
        M.size*=(Optionen-i);

    /* Wir gehen davon aus, dass 'sizeof(char)==1'
       und ein 'char' somit 8 Bits entspricht. */
    if (sizeof(char)!=1)
    {
        fprintf(stderr,"Interner Fehler.\n");
        return 2;
    }
    charZahl=(M.size+7)/8;

    printf("Optionen: %u, Msize: %u, charZahl: %u.\n",Optionen,M.size,charZahl);

    M.elem=calloc(charZahl,1);
    for(i=0;i<charZahl;i++)
        M.elem[i]=255;

    ZufallsCode(Tip,Optionen,0);
    printf("\nMein Tip: "); printCode(Tip); printf(".\n");

    while (readBewertung(&b))
    {
        printf("ungueltige Eingabe!\n");
    }
    berechneVerbleibende(M,Tip,b,Optionen);

    while (1)
    {
        if (berechneTip(Tip,M,Optionen)<0)
        {
            printf("Keine verbleibenden Moeglichkeiten.\n");
            printf("Haben Sie sich vertippt?\n");
            return 1;
        }
        printf("\nMein Tip: "); printCode(Tip); printf(".\n");
        while (readBewertung(&b))
        {
            printf("Geben Sie eine gueltige Bewertung ein!\n");
        }
        if (b.schwarz==4)
        {
            printf("Das war also die Loesung.\n");
            break;
        }
        berechneVerbleibende(M,Tip,b,Optionen);
    }

    free(M.elem);
    return 0;
}
