/* Mastermind-Spiel:
 * Der Computer denkt sich eine Zahl aus
 *  - der Spieler muss sie erraten.
 *
 * Stefan Arnold XI.03
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* Anzahl der Zahlen im Geheimcode */
#define CODELAENGE 4

#include "Mastermind.h"

const int mitVielfachheiten=0;

/* Startet das Mastermind-Spiel. */
int main()
{
    code Code,Tip;
    bewertung Bewertung;
    zahl Optionen;
    int i,Fehler;
    unsigned int input;
    char Eingabe;

    /* Einlesen der groessten erlaubten Zahl in Codes */
    printf("Wieviele Zahlen sollen zur Auswahl stehen?\n");
    scanf("%d",&input);
    if (input==0)
    {
        printf("Dann halt nicht...\n");
        return 0;
    }
    Optionen=(zahl)(input>(unsigned int)MAX_OPTIONEN? MAX_OPTIONEN: input);
    printf("Sie koennen aus den Zahlen 0..%u auswaehlen.\n",Optionen-1);

    /* Erzeugen des Geheimcodes */
    ZufallsCode(Code,Optionen,mitVielfachheiten);

    /* Nicht schummeln! */
    /* printf("Der Code lautet "); printCode(Code); putchar('\n');
    */

    /* Durchfuehrung der Rateschritte */
    for(i=0;i<MAX_SCHRITTE;i++)
    {
        while (Fehler=readCode(Tip,Optionen,mitVielfachheiten))
        /* man knnte auch Tips zulassen, die keine Loesung sein koennen: */
        /* while (Fehler=readCode(Tip,Optionen,0)) */
        {
            if (Fehler==EOF)
            {
                printf("Bis zum naechsten Mal...\n");
                return 0;
            }
            printf("Geben Sie %u %sZahlen im Bereich 0..%u ein!\n",
                CODELAENGE,mitVielfachheiten? "": "verschiedene ",Optionen);
            printf("Oder wollen Sie das Spiel beenden? ('n'=nein, <sonst>=ja)\n");
            fflush(stdin);
            Eingabe=(char)getchar();
            if(Eingabe!='n')
                return 0;
        }
        Bewertung=getBewertung(Code,Tip,Optionen);
        if (Bewertung.schwarz==4)
        {
            if(i!=0)
                printf("Gewonnen! Sie haben %d Rateschritte benoetigt.\n",i+1);
            else
                printf("Gewonnen! Sie haben nur einen Rateschritt benoetigt.\n");
            return 0;
        }
        printf("schwarze Stifte: %u, weisse Stifte: %u.\n\n",Bewertung.schwarz,Bewertung.weiss);
    }
    printf("Leider haben Sie es nicht geschafft, den Code zu erraten.\n");
    printf("Der Code lautete '"); printCode(Code); printf("'.\n");
    return 0;
}
